'this subroutine returns a sting containing the list of subroutines in library.prg.  This is useful for writing a wrapper program that calls one of these subroutines, especially when used in conjunction with the getfuncdiscs below
subroutine getfuncnames(string %s)
	%s = "accumdist accumswing avtr bollinger chaikinflow chaikinosc chaikinvol chande cci csi directmov dema dmi dpo ema emv imi klinger macd mfi massidx monfi movav movtrendslope nvi obv perform priceosc projosc pvi pvt qstick ri rsi smi stochosc swing tema trix ultosc volosc wildsmooth willaccdist willr"
endsub

'this subroutine returns a subset of the above list, based on the index numbers containted in the index string, %index
subroutine getfuncnamesidx(string %s, string %index)
	%full = ""
	call getfuncnames(%full)
	for !i=1 to @wcount(%index)
		!j = @val(@word(%index,!i))
		%s = %s + @word(%full,!j) + " "
	next
	%s = @trim(%s)
endsub


'this subroutine returns a sting containing a list of descriptions of the subroutines in library.prg.  This is useful for writing a wrapper program that calls one of these subroutines, especially when used in conjunction with the getfuncnames above
subroutine getfuncdiscs(string %s)
	%s = """Accumulation Distribution"" ""Accumulation Swing Index"" ""Average True Range"" ""Bollinger Bands"" ""Chaikin's Money Flow"" ""Chaikin's Oscillator"" ""Chaikin's Volatility"" ""Chande Momentum Oscillator"" ""Commodity Channel Index"" ""Commodity Selection Index"" ""Directional Movment Indicators""  ""Double Exponential Moving Average"" ""Dynamic Momentum Index"" ""Detrended Price Oscillator"" ""Exponential Moving Average"" ""Ease of Movement"" ""Intraday Momentum Index"" ""Klinger Oscillator"" ""MACD"" ""Market Facilitation Index"" ""Mass Index"" ""Money Flow Index"" ""Moving Average"" ""Moving Slope"" ""Negative Volume Index"" ""On Balance Volume"" ""Performance"" ""Price Oscillator"" ""Projection Oscillator"" ""Positive Volume Index"" ""Price and Volume Trend"" ""QStick"" ""Range Indicator"" ""Relative Strength Index"" ""Stocahstic Momentum Index"" ""Stochastic Oscillator"" ""Swing Index"" ""Triple Exponential Moving Average"" ""TRIX"" ""Ultimate Oscillator"" ""Volume Oscillator"" ""Wilder's Smoothing"" ""Williams' Accumulation-Distribution"" ""Williams' %R""          "
endsub

'this subroutine returns a subset of the above list, based on the index numbers containted in the index string, %index
subroutine getfuncdiscsidx(string %s, string %index)
	%full = ""
	call getfuncdiscs(%full)
	for !i=1 to @wcount(%index)
		!j = @val(@word(%index,!i))
		%s = %s + @wordq(%full,!j) + " "
	next
	%s = @trim(%s)
endsub


'this subroutine returns a string containing a code that identifies which input series the functions require.
subroutine getinputtypes(string %s)
	%s = "hlcv hlocs hlcs special hlcvs hlcv hls cs hlcs special special cs c cs cs hlvs ocs hlcv c hlv hls hlcvs special cs cv cv c special hlcs cv cv ocs special cs special special hlocs cs cs hlc special cs hlc hlcs"
endsub

'this subroutine sorts an input code string so that it is in the required "hlocvs" order
subroutine sortinputcode(string %code)
	%outstring = ""
	for %j "h" "l" "o" "c" "v" "s"
		if @instr(%code,%j) then
			%outstring = %outstring + %j
		endif
	next
	%code = %outstring
endsub

'this subroutine returns a subset of the above list, based on the index numbers containted in the index string, %index
subroutine getinputtypesidx(string %s, string %index)
	%full = ""
	call getinputtypes(%full)
	for !i=1 to @wcount(%index)
		!j = @val(@word(%index,!i))
		%s = %s + @word(%full,!j) + " "
	next
	%s = @trim(%s)
endsub


'this subroutine selects only the functions whose inputs match those in %inputs, and puts the index (i.e. the position in the list) of those functions in a space delimited list in %funcs
'currently doesn't handle "specials"
subroutine matchfuncs(string %inputs, string %funcs)
	'sort the input code so that it is in the correct "hlocvs" order
	call sortinputcode(%inputs)
	
	'get the full list of function inputs
	%fulllist = ""
	call getinputtypes(%fulllist)
	
	'match the input code to elements of the full list.
	for !i = 1 to @wcount(%fulllist)
		%func = @word(%fulllist,!i)
		if %func <> "special" then
			if @right(%func,1) = "s" then
				%func = @left(%func,@length(%func)-1)
			endif
			if %inputs = %func then
				%funcs = %funcs + @str(!i) + " "
			endif
		endif
	next
endsub
